<a id="mypy-boto3-evidently"></a>

# mypy-boto3-evidently

[![PyPI - mypy-boto3-evidently](https://img.shields.io/pypi/v/mypy-boto3-evidently.svg?color=blue)](https://pypi.org/project/mypy-boto3-evidently)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-evidently.svg?color=blue)](https://pypi.org/project/mypy-boto3-evidently)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)
[![PyPI - Downloads](https://img.shields.io/pypi/dm/mypy-boto3-evidently?color=blue)](https://pypistats.org/packages/mypy-boto3-evidently)

![boto3.typed](https://github.com/vemel/mypy_boto3_builder/raw/master/logo.png)

Type annotations for
[boto3.CloudWatchEvidently 1.20.35](https://boto3.amazonaws.com/v1/documentation/api/1.20.35/reference/services/evidently.html#CloudWatchEvidently)
service compatible with [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright) and other tools.

Generated by
[mypy-boto3-builder 6.3.2](https://github.com/vemel/mypy_boto3_builder).

More information can be found on
[boto3-stubs](https://pypi.org/project/boto3-stubs/) page and in
[mypy-boto3-evidently docs](https://vemel.github.io/boto3_stubs_docs/mypy_boto3_evidently/)

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/vemel/mypy_boto3_builder/raw/master/demo.gif)

- [mypy-boto3-evidently](#mypy-boto3-evidently)
  - [How to install](#how-to-install)
    - [VSCode extension](#vscode-extension)
    - [From PyPI with pip](#from-pypi-with-pip)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)
    - [Literals](#literals)
    - [Typed dictionaries](#typed-dictionaries)
  - [Versioning](#versioning)
  - [Documentation](#documentation)
  - [Support and contributing](#support-and-contributing)

<a id="how-to-install"></a>

## How to install

<a id="vscode-extension"></a>

### VSCode extension

Add
[AWS Boto3](https://marketplace.visualstudio.com/items?itemName=Boto3typed.boto3-ide)
extension to your VSCode and run `AWS boto3: Quick Start` command.

Click `Modify` and select `boto3 common` and `CloudWatchEvidently`.

<a id="from-pypi-with-pip"></a>

### From PyPI with pip

Install `boto3-stubs` for `CloudWatchEvidently` service.

```bash
python -m pip install boto3-stubs[evidently]
```

<a id="usage"></a>

## Usage

<a id="vscode"></a>

### VSCode

- Install
  [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install
  [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `boto-stubs[evidently]` in your environment:
  `python -m pip install 'boto3-stubs[evidently]'`

Both type checking and auto-complete should work for `CloudWatchEvidently`
service. No explicit type annotations required, write your `boto3` code as
usual.

<a id="pycharm"></a>

### PyCharm

- Install `boto-stubs[evidently]` in your environment:
  `python -m pip install 'boto3-stubs[evidently]'`

Both type checking and auto-complete should work for `CloudWatchEvidently`
service. No explicit type annotations required, write your `boto3` code as
usual. Auto-complete can be slow on big projects or if you have a lot of
installed `boto3-stubs` submodules.

<a id="other-ides"></a>

### Other IDEs

Not tested, but as long as your IDE supports `mypy` or `pyright`, everything
should work.

<a id="mypy"></a>

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `boto-stubs[evidently]` in your environment:
  `python -m pip install 'boto3-stubs[evidently]'`
- Run `mypy` as usual

Type checking should work for `CloudWatchEvidently` service. No explicit type
annotations required, write your `boto3` code as usual.

<a id="pyright"></a>

### pyright

- Install `pyright`: `yarn global add pyright`
- Install `boto-stubs[evidently]` in your environment:
  `python -m pip install 'boto3-stubs[evidently]'`
- Optionally, you can install `boto3-stubs` to `typings` folder.

Type checking should work for `CloudWatchEvidently` service. No explicit type
annotations required, write your `boto3` code as usual.

<a id="explicit-type-annotations"></a>

## Explicit type annotations

<a id="client-annotations"></a>

### Client annotations

`CloudWatchEvidentlyClient` provides annotations for
`boto3.client("evidently")`.

```python
import boto3

from mypy_boto3_evidently import CloudWatchEvidentlyClient

client: CloudWatchEvidentlyClient = boto3.client("evidently")

# now client usage is checked by mypy and IDE should provide code auto-complete

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: CloudWatchEvidentlyClient = session.client("evidently")
```

<a id="paginators-annotations"></a>

### Paginators annotations

`mypy_boto3_evidently.paginator` module contains type annotations for all
paginators.

```python
from mypy_boto3_evidently import CloudWatchEvidentlyClient
from mypy_boto3_evidently.paginator import (
    ListExperimentsPaginator,
    ListFeaturesPaginator,
    ListLaunchesPaginator,
    ListProjectsPaginator,
)

client: CloudWatchEvidentlyClient = boto3.client("evidently")

# Explicit type annotations are optional here
# Type should be correctly discovered by mypy and IDEs
# VSCode requires explicit type annotations
list_experiments_paginator: ListExperimentsPaginator = client.get_paginator("list_experiments")
list_features_paginator: ListFeaturesPaginator = client.get_paginator("list_features")
list_launches_paginator: ListLaunchesPaginator = client.get_paginator("list_launches")
list_projects_paginator: ListProjectsPaginator = client.get_paginator("list_projects")
```

<a id="literals"></a>

### Literals

`mypy_boto3_evidently.literals` module contains literals extracted from shapes
that can be used in user code for type checking.

```python
from mypy_boto3_evidently.literals import (
    ChangeDirectionEnumType,
    EventTypeType,
    ExperimentBaseStatType,
    ExperimentReportNameType,
    ExperimentResultRequestTypeType,
    ExperimentResultResponseTypeType,
    ExperimentStatusType,
    ExperimentStopDesiredStateType,
    ExperimentTypeType,
    FeatureEvaluationStrategyType,
    FeatureStatusType,
    LaunchStatusType,
    LaunchStopDesiredStateType,
    LaunchTypeType,
    ListExperimentsPaginatorName,
    ListFeaturesPaginatorName,
    ListLaunchesPaginatorName,
    ListProjectsPaginatorName,
    ProjectStatusType,
    VariationValueTypeType,
    ServiceName,
    PaginatorName,
)

def check_value(value: ChangeDirectionEnumType) -> bool:
    ...
```

<a id="typed-dictionaries"></a>

### Typed dictionaries

`mypy_boto3_evidently.type_defs` module contains structures and shapes
assembled to typed dictionaries for additional type checking.

```python
from mypy_boto3_evidently.type_defs import (
    BatchEvaluateFeatureRequestRequestTypeDef,
    BatchEvaluateFeatureResponseTypeDef,
    CloudWatchLogsDestinationConfigTypeDef,
    CloudWatchLogsDestinationTypeDef,
    CreateExperimentRequestRequestTypeDef,
    CreateExperimentResponseTypeDef,
    CreateFeatureRequestRequestTypeDef,
    CreateFeatureResponseTypeDef,
    CreateLaunchRequestRequestTypeDef,
    CreateLaunchResponseTypeDef,
    CreateProjectRequestRequestTypeDef,
    CreateProjectResponseTypeDef,
    DeleteExperimentRequestRequestTypeDef,
    DeleteFeatureRequestRequestTypeDef,
    DeleteLaunchRequestRequestTypeDef,
    DeleteProjectRequestRequestTypeDef,
    EvaluateFeatureRequestRequestTypeDef,
    EvaluateFeatureResponseTypeDef,
    EvaluationRequestTypeDef,
    EvaluationResultTypeDef,
    EvaluationRuleTypeDef,
    EventTypeDef,
    ExperimentExecutionTypeDef,
    ExperimentReportTypeDef,
    ExperimentResultsDataTypeDef,
    ExperimentScheduleTypeDef,
    ExperimentTypeDef,
    FeatureSummaryTypeDef,
    FeatureTypeDef,
    GetExperimentRequestRequestTypeDef,
    GetExperimentResponseTypeDef,
    GetExperimentResultsRequestRequestTypeDef,
    GetExperimentResultsResponseTypeDef,
    GetFeatureRequestRequestTypeDef,
    GetFeatureResponseTypeDef,
    GetLaunchRequestRequestTypeDef,
    GetLaunchResponseTypeDef,
    GetProjectRequestRequestTypeDef,
    GetProjectResponseTypeDef,
    LaunchExecutionTypeDef,
    LaunchGroupConfigTypeDef,
    LaunchGroupTypeDef,
    LaunchTypeDef,
    ListExperimentsRequestRequestTypeDef,
    ListExperimentsResponseTypeDef,
    ListFeaturesRequestRequestTypeDef,
    ListFeaturesResponseTypeDef,
    ListLaunchesRequestRequestTypeDef,
    ListLaunchesResponseTypeDef,
    ListProjectsRequestRequestTypeDef,
    ListProjectsResponseTypeDef,
    ListTagsForResourceRequestRequestTypeDef,
    ListTagsForResourceResponseTypeDef,
    MetricDefinitionConfigTypeDef,
    MetricDefinitionTypeDef,
    MetricGoalConfigTypeDef,
    MetricGoalTypeDef,
    MetricMonitorConfigTypeDef,
    MetricMonitorTypeDef,
    OnlineAbConfigTypeDef,
    OnlineAbDefinitionTypeDef,
    PaginatorConfigTypeDef,
    ProjectDataDeliveryConfigTypeDef,
    ProjectDataDeliveryTypeDef,
    ProjectSummaryTypeDef,
    ProjectTypeDef,
    PutProjectEventsRequestRequestTypeDef,
    PutProjectEventsResponseTypeDef,
    PutProjectEventsResultEntryTypeDef,
    ResponseMetadataTypeDef,
    S3DestinationConfigTypeDef,
    S3DestinationTypeDef,
    ScheduledSplitConfigTypeDef,
    ScheduledSplitTypeDef,
    ScheduledSplitsLaunchConfigTypeDef,
    ScheduledSplitsLaunchDefinitionTypeDef,
    StartExperimentRequestRequestTypeDef,
    StartExperimentResponseTypeDef,
    StartLaunchRequestRequestTypeDef,
    StartLaunchResponseTypeDef,
    StopExperimentRequestRequestTypeDef,
    StopExperimentResponseTypeDef,
    StopLaunchRequestRequestTypeDef,
    StopLaunchResponseTypeDef,
    TagResourceRequestRequestTypeDef,
    TreatmentConfigTypeDef,
    TreatmentTypeDef,
    UntagResourceRequestRequestTypeDef,
    UpdateExperimentRequestRequestTypeDef,
    UpdateExperimentResponseTypeDef,
    UpdateFeatureRequestRequestTypeDef,
    UpdateFeatureResponseTypeDef,
    UpdateLaunchRequestRequestTypeDef,
    UpdateLaunchResponseTypeDef,
    UpdateProjectDataDeliveryRequestRequestTypeDef,
    UpdateProjectDataDeliveryResponseTypeDef,
    UpdateProjectRequestRequestTypeDef,
    UpdateProjectResponseTypeDef,
    VariableValueTypeDef,
    VariationConfigTypeDef,
    VariationTypeDef,
)

def get_structure() -> BatchEvaluateFeatureRequestRequestTypeDef:
    return {
      ...
    }
```

<a id="versioning"></a>

## Versioning

`mypy-boto3-evidently` version is the same as related `boto3` version and
follows [PEP 440](https://www.python.org/dev/peps/pep-0440/) format.

<a id="documentation"></a>

## Documentation

All type annotations can be found in
[mypy-boto3-evidently docs](https://vemel.github.io/boto3_stubs_docs/mypy_boto3_evidently/)

<a id="support-and-contributing"></a>

## Support and contributing

This package is auto-generated. Please reports any bugs or request new features
in [mypy-boto3-builder](https://github.com/vemel/mypy_boto3_builder/issues/)
repository.
